/* ESERCIZIO (del 25-5-2018)
 Un Tipo Astratto 't queue per code polimorfe di valori di tipo generico 't \`e un valore
 strutturato MUTABLE dotato delle seguenti operazioni con signature funzionale:
    isEmpty: 't queue -> bool
    isIn: 't queue -> 't -> int    (quante occorrenze del secondo argomento)
    get: 't queue -> 't
    add: 't queue -> 't -> 't queue
    remove 't queue -> 't queue
    removeAll 't queue -> 't -> 't queue       (rimuove gli uguali al secondo argomento)
 e, in aggiunta:
    + un costruttore pubblico che inizializza la coda agli elementi della lista a cui e'
      applicato;
    + eccezioni pubbliche che si ritenga utile aggiungere;
    + toString: 't queue -> string
    + clone: 't queue -> 't queue
 Si forniscano API ed ADT con AF ed I e si esegua il test nel file accluso
 
 Prologo: Intero sviluppo in package di nome StackPack
 Prologo: Creare 4 file:
 1 per la API API<A>
 1 per la classe Queue<A>
 1 per le eccezioni, newExc
 1 per i codici di tests.
 (a) Fornire API
 (b) Fornire Stato Concreto, AF e C
 (c-d-e-f) Sviluppo:
 (c) Fornire successiva operazione nell'ordine e
 ad ogni definizione procedere con (d),(e),(f)
 (d) Completare la segnatura con le eccezioni sollevate
 (e) Aggiungere definizione classi di eccezioni relative
 (f) compilare ed eseguire test di uso
 */

package QueuePack;
import java.util.*;

public interface API<A> extends Cloneable{
	public boolean isEmpty();
    public int isIn(A x);
    public A get() throws EmptyQueueException;
    public void add(A x);
    public void remove() throws EmptyQueueException;
    public void removeAll(A x);
}

