/* ESERCIZIO (del 25-5-2018)
 Un Tipo Astratto 't queue per code polimorfe di valori di tipo generico 't \`e un
 valore strutturato MUTABLE dotato delle operazioni che possiamo vedere nella API,
 API<T>, allegata.
 API<T> non contiene operazioni sulla dimensione corrente e ancor meno, sulla dimen-
 sione massima che ha avuta la coda nella sua storia passa.
 Si chiede di estendere il tipo astratto in un nuovo tipo che contenga anche le ope-
 razioni size e maxsize. Allo scopo, si completino i file allegati:
 + APIV1.java
 + QueueV1.java
 + mewExcV1.java
 + TestsV1.java
 
 Prologo: Intero sviluppo in package di nome QueuePack
 Prologo: Creare 4 file:
 1 per la API API<A>
 1 per la classe Queue<A>
 1 per le eccezioni, newExc
 1 per i codici di tests.
 (a) Fornire API
 (b) Fornire Stato Concreto, AF e C
 (c-d-e-f) Sviluppo:
 (c) Fornire successiva operazione nell'ordine e
 ad ogni definizione procedere con (d),(e),(f)
 (d) Completare la segnatura con le eccezioni sollevate
 (e) Aggiungere definizione classi di eccezioni relative
 (f) compilare ed eseguire test di uso
 */
package QueuePack;

import java.io.*;
import java.util.*;

class Test{//Eseguire
    public static void main(String[] args) throws EmptyQueueException{
        Queue<String> q1;
        Vector<String> inlist = new Vector<String>();
        inlist.add("luigi");
        inlist.add("luca");
        inlist.add("laura");
        inlist.add("michele");
        q1 = new Queue<String>(inlist);
        q1.remove();
        q1.add("luca");
        q1.add("giacomo");
        q1.add("luca");
        q1.add("luciano");
        q1.add("franca");
        q1.add("silvia");
        System.out.println("the current status of q1 is: " + q1.toString());
        System.out.println("How many Luca in ? - " + q1.isIn("Luca"));
        System.out.println("How many luca in ? - " + q1.isIn("luca"));
        q1.removeAll("luca");
        System.out.println("the current status of q1 is: " + q1.toString());
    }
}
class Test1{//Corregere (1 errore usando il compilatore) ed eseguire
    public static void main(String[] args) throws EmptyQueueException{
        Queue<String> q1;
        Vector<String> inlist = new Vector<String>();
        inlist.add("luigi");
        inlist.add("luca");
        inlist.add("laura");
        inlist.add("michele");
        q1 = new Queue<String>(inlist);
        System.out.println("the current status of q1 is: " + q1);
        QueueV1<String> q2 = new QueueV1<String>(inlist);
        System.out.println("the size of q2 is: " + q2.size());
        q2.remove();
        q2.add("luca");
        q2.add("giacomo");
        q2.add("luca");
        q2.add("luciano");
        q2.add("franca");
        q2.add("silvia");
        System.out.println("the current status of q2 is: " + q2);
        System.out.println("the current maxsize of q2 is: " + q1.maxsize());
        q2.removeAll("luca");
        System.out.println("the current status of q2 is: " + q2);
        q2.remove();
        q2.remove();
        q2.remove();
        System.out.println("the size of q2 is: " + q2.size() + ";  whilst its maxsize has been: " + q2.maxsize());
    }
}

